# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

variables:
  DOCKER_TLS_CERTDIR: "/certs"

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - deploy
  - run

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - |
        cat > hello << EOF
        #!/bin/sh
        echo hello \$* !
        EOF
    - chmod +x hello
  artifacts:
    paths:
      - hello

unit-test-job:   # This job runs in the test stage.
  stage: test
  needs: ["build-job"]    # It only starts when the job in the build stage completes successfully.
  script:
    - bash testunit -j
  artifacts:
    when: always
    reports:
      junit: testunit-tests.xml

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  image: docker
  services:
    - docker:dind
  needs: ["build-job"]
  script:
    - docker build -t hello .
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY/jerome.xlinfo/hello .
    - docker push $CI_REGISTRY/jerome.xlinfo/hello

run-job:
  stage: run
  image:  $CI_REGISTRY/jerome.xlinfo/hello
  script:
    - docker info
  

